<?php

namespace rdyescapia\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDamageWaiverOptionType ArrayType
 * @subpackage Arrays
 */
class ArrayOfDamageWaiverOptionType extends AbstractStructArrayBase
{
    /**
     * The DamageWaiverOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\DamageWaiverOptionType[]
     */
    public $DamageWaiverOption;
    /**
     * Constructor method for ArrayOfDamageWaiverOptionType
     * @uses ArrayOfDamageWaiverOptionType::setDamageWaiverOption()
     * @param \rdyescapia\StructType\DamageWaiverOptionType[] $damageWaiverOption
     */
    public function __construct(array $damageWaiverOption = array())
    {
        $this
            ->setDamageWaiverOption($damageWaiverOption);
    }
    /**
     * Get DamageWaiverOption value
     * @return \rdyescapia\StructType\DamageWaiverOptionType[]|null
     */
    public function getDamageWaiverOption()
    {
        return $this->DamageWaiverOption;
    }
    /**
     * This method is responsible for validating the values passed to the setDamageWaiverOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDamageWaiverOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDamageWaiverOptionForArrayConstraintsFromSetDamageWaiverOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem instanceof \rdyescapia\StructType\DamageWaiverOptionType) {
                $invalidValues[] = is_object($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) ? get_class($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem) : sprintf('%s(%s)', gettype($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem), var_export($arrayOfDamageWaiverOptionTypeDamageWaiverOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DamageWaiverOption property can only contain items of type \rdyescapia\StructType\DamageWaiverOptionType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DamageWaiverOption value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\DamageWaiverOptionType[] $damageWaiverOption
     * @return \rdyescapia\ArrayType\ArrayOfDamageWaiverOptionType
     */
    public function setDamageWaiverOption(array $damageWaiverOption = array())
    {
        // validation for constraint: array
        if ('' !== ($damageWaiverOptionArrayErrorMessage = self::validateDamageWaiverOptionForArrayConstraintsFromSetDamageWaiverOption($damageWaiverOption))) {
            throw new \InvalidArgumentException($damageWaiverOptionArrayErrorMessage, __LINE__);
        }
        $this->DamageWaiverOption = $damageWaiverOption;
        return $this;
    }
    /**
     * Add item to DamageWaiverOption value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\DamageWaiverOptionType $item
     * @return \rdyescapia\ArrayType\ArrayOfDamageWaiverOptionType
     */
    public function addToDamageWaiverOption(\rdyescapia\StructType\DamageWaiverOptionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\DamageWaiverOptionType) {
            throw new \InvalidArgumentException(sprintf('The DamageWaiverOption property can only contain items of type \rdyescapia\StructType\DamageWaiverOptionType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DamageWaiverOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapia\StructType\DamageWaiverOptionType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapia\StructType\DamageWaiverOptionType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapia\StructType\DamageWaiverOptionType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapia\StructType\DamageWaiverOptionType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapia\StructType\DamageWaiverOptionType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DamageWaiverOption
     */
    public function getAttributeName()
    {
        return 'DamageWaiverOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\ArrayType\ArrayOfDamageWaiverOptionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
