<?php

namespace rdyescapia\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVendorMessageType ArrayType
 * @subpackage Arrays
 */
class ArrayOfVendorMessageType extends AbstractStructArrayBase
{
    /**
     * The VendorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\VendorMessageType[]
     */
    public $VendorMessage;
    /**
     * Constructor method for ArrayOfVendorMessageType
     * @uses ArrayOfVendorMessageType::setVendorMessage()
     * @param \rdyescapia\StructType\VendorMessageType[] $vendorMessage
     */
    public function __construct(array $vendorMessage = array())
    {
        $this
            ->setVendorMessage($vendorMessage);
    }
    /**
     * Get VendorMessage value
     * @return \rdyescapia\StructType\VendorMessageType[]|null
     */
    public function getVendorMessage()
    {
        return $this->VendorMessage;
    }
    /**
     * This method is responsible for validating the values passed to the setVendorMessage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVendorMessage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVendorMessageForArrayConstraintsFromSetVendorMessage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVendorMessageTypeVendorMessageItem) {
            // validation for constraint: itemType
            if (!$arrayOfVendorMessageTypeVendorMessageItem instanceof \rdyescapia\StructType\VendorMessageType) {
                $invalidValues[] = is_object($arrayOfVendorMessageTypeVendorMessageItem) ? get_class($arrayOfVendorMessageTypeVendorMessageItem) : sprintf('%s(%s)', gettype($arrayOfVendorMessageTypeVendorMessageItem), var_export($arrayOfVendorMessageTypeVendorMessageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VendorMessage property can only contain items of type \rdyescapia\StructType\VendorMessageType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VendorMessage value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\VendorMessageType[] $vendorMessage
     * @return \rdyescapia\ArrayType\ArrayOfVendorMessageType
     */
    public function setVendorMessage(array $vendorMessage = array())
    {
        // validation for constraint: array
        if ('' !== ($vendorMessageArrayErrorMessage = self::validateVendorMessageForArrayConstraintsFromSetVendorMessage($vendorMessage))) {
            throw new \InvalidArgumentException($vendorMessageArrayErrorMessage, __LINE__);
        }
        $this->VendorMessage = $vendorMessage;
        return $this;
    }
    /**
     * Add item to VendorMessage value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\VendorMessageType $item
     * @return \rdyescapia\ArrayType\ArrayOfVendorMessageType
     */
    public function addToVendorMessage(\rdyescapia\StructType\VendorMessageType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\VendorMessageType) {
            throw new \InvalidArgumentException(sprintf('The VendorMessage property can only contain items of type \rdyescapia\StructType\VendorMessageType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VendorMessage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapia\StructType\VendorMessageType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapia\StructType\VendorMessageType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapia\StructType\VendorMessageType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapia\StructType\VendorMessageType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapia\StructType\VendorMessageType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VendorMessage
     */
    public function getAttributeName()
    {
        return 'VendorMessage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\ArrayType\ArrayOfVendorMessageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
