<?php

namespace rdyescapia;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'EVRN_UnitDescriptiveInfoRQ' => '\\rdyescapia\\StructType\\EVRN_UnitDescriptiveInfoRQ',
            'EVRN_BaseRQType' => '\\rdyescapia\\StructType\\EVRN_BaseRQType',
            'ArrayOfSourceType' => '\\rdyescapia\\ArrayType\\ArrayOfSourceType',
            'SourceType' => '\\rdyescapia\\StructType\\SourceType',
            'RequestorID' => '\\rdyescapia\\StructType\\RequestorID',
            'BookingChannelType' => '\\rdyescapia\\StructType\\BookingChannelType',
            'CompanyNameType' => '\\rdyescapia\\StructType\\CompanyNameType',
            'TravelArrangerType' => '\\rdyescapia\\StructType\\TravelArrangerType',
            'CompanyNamePrefType' => '\\rdyescapia\\StructType\\CompanyNamePrefType',
            'UnitResRequestType' => '\\rdyescapia\\StructType\\UnitResRequestType',
            'UniqueID_Type' => '\\rdyescapia\\StructType\\UniqueID_Type',
            'UnitReservationsType' => '\\rdyescapia\\StructType\\UnitReservationsType',
            'UnitReservationType' => '\\rdyescapia\\StructType\\UnitReservationType',
            'ArrayOfUnitStaysTypeUnitStay' => '\\rdyescapia\\ArrayType\\ArrayOfUnitStaysTypeUnitStay',
            'UnitStay' => '\\rdyescapia\\StructType\\UnitStay',
            'Reference' => '\\rdyescapia\\StructType\\Reference',
            'UnitStayType' => '\\rdyescapia\\StructType\\UnitStayType',
            'UnitInsuranceInfo' => '\\rdyescapia\\StructType\\UnitInsuranceInfo',
            'ArrayOfUnitStayTypeUnitRate' => '\\rdyescapia\\ArrayType\\ArrayOfUnitStayTypeUnitRate',
            'UnitRate' => '\\rdyescapia\\StructType\\UnitRate',
            'ArrayOfEVRN_AmountType' => '\\rdyescapia\\ArrayType\\ArrayOfEVRN_AmountType',
            'EVRN_AmountType' => '\\rdyescapia\\StructType\\EVRN_AmountType',
            'AdditionalGuestAmounts' => '\\rdyescapia\\StructType\\AdditionalGuestAmounts',
            'Discount' => '\\rdyescapia\\StructType\\Discount',
            'AdditionalCharges' => '\\rdyescapia\\StructType\\AdditionalCharges',
            'AdvanceBookingRestriction' => '\\rdyescapia\\StructType\\AdvanceBookingRestriction',
            'TotalType' => '\\rdyescapia\\StructType\\TotalType',
            'TaxesType' => '\\rdyescapia\\StructType\\TaxesType',
            'TaxType' => '\\rdyescapia\\StructType\\TaxType',
            'ParagraphType' => '\\rdyescapia\\StructType\\ParagraphType',
            'ListItem' => '\\rdyescapia\\StructType\\ListItem',
            'FormattedTextTextType' => '\\rdyescapia\\StructType\\FormattedTextTextType',
            'DiscountType' => '\\rdyescapia\\StructType\\DiscountType',
            'RateDiscountType' => '\\rdyescapia\\StructType\\RateDiscountType',
            'AdditionalGuestAmountType' => '\\rdyescapia\\StructType\\AdditionalGuestAmountType',
            'ArrayOfFeeType' => '\\rdyescapia\\ArrayType\\ArrayOfFeeType',
            'FeeType' => '\\rdyescapia\\StructType\\FeeType',
            'CommissionPolicyType' => '\\rdyescapia\\StructType\\CommissionPolicyType',
            'CancelPenaltiesType' => '\\rdyescapia\\StructType\\CancelPenaltiesType',
            'CancelPenaltyType' => '\\rdyescapia\\StructType\\CancelPenaltyType',
            'Deadline' => '\\rdyescapia\\StructType\\Deadline',
            'AmountPercentType' => '\\rdyescapia\\StructType\\AmountPercentType',
            'ArrayOfRequiredPaymentsTypeGuaranteePayment' => '\\rdyescapia\\ArrayType\\ArrayOfRequiredPaymentsTypeGuaranteePayment',
            'GuaranteePayment' => '\\rdyescapia\\StructType\\GuaranteePayment',
            'Address' => '\\rdyescapia\\StructType\\Address',
            'ArrayOfPaymentFormType' => '\\rdyescapia\\ArrayType\\ArrayOfPaymentFormType',
            'PaymentFormType' => '\\rdyescapia\\StructType\\PaymentFormType',
            'Cash' => '\\rdyescapia\\StructType\\Cash',
            'LoyaltyRedemption' => '\\rdyescapia\\StructType\\LoyaltyRedemption',
            'MiscChargeOrder' => '\\rdyescapia\\StructType\\MiscChargeOrder',
            'Voucher' => '\\rdyescapia\\StructType\\Voucher',
            'BankAcctType' => '\\rdyescapia\\StructType\\BankAcctType',
            'AddressType' => '\\rdyescapia\\StructType\\AddressType',
            'StreetNmbr' => '\\rdyescapia\\StructType\\StreetNmbr',
            'BldgRoom' => '\\rdyescapia\\StructType\\BldgRoom',
            'StreetNmbrType' => '\\rdyescapia\\StructType\\StreetNmbrType',
            'StateProvType' => '\\rdyescapia\\StructType\\StateProvType',
            'CountryNameType' => '\\rdyescapia\\StructType\\CountryNameType',
            'AddressInfoType' => '\\rdyescapia\\StructType\\AddressInfoType',
            'DirectBillType' => '\\rdyescapia\\StructType\\DirectBillType',
            'CompanyName' => '\\rdyescapia\\StructType\\CompanyName',
            'PaymentCardType' => '\\rdyescapia\\StructType\\PaymentCardType',
            'CardIssuerName' => '\\rdyescapia\\StructType\\CardIssuerName',
            'TPA_Extensions_Type' => '\\rdyescapia\\StructType\\TPA_Extensions_Type',
            'AdditionalChargeType' => '\\rdyescapia\\StructType\\AdditionalChargeType',
            'GuestCountType' => '\\rdyescapia\\StructType\\GuestCountType',
            'GuestCount' => '\\rdyescapia\\StructType\\GuestCount',
            'DateTimeSpanType' => '\\rdyescapia\\StructType\\DateTimeSpanType',
            'EndDateWindow' => '\\rdyescapia\\StructType\\EndDateWindow',
            'StartDateWindow' => '\\rdyescapia\\StructType\\StartDateWindow',
            'TimeInstantType' => '\\rdyescapia\\StructType\\TimeInstantType',
            'BasicUnitInfoType' => '\\rdyescapia\\StructType\\BasicUnitInfoType',
            'Position' => '\\rdyescapia\\StructType\\Position',
            'Award' => '\\rdyescapia\\StructType\\Award',
            'ArrayOfVendorMessageType' => '\\rdyescapia\\ArrayType\\ArrayOfVendorMessageType',
            'VendorMessageType' => '\\rdyescapia\\StructType\\VendorMessageType',
            'FormattedTextType' => '\\rdyescapia\\StructType\\FormattedTextType',
            'FormattedTextSubSectionType' => '\\rdyescapia\\StructType\\FormattedTextSubSectionType',
            'ArrayOfBasicUnitInfoTypeContactNumber' => '\\rdyescapia\\ArrayType\\ArrayOfBasicUnitInfoTypeContactNumber',
            'ContactNumber' => '\\rdyescapia\\StructType\\ContactNumber',
            'UnitAmenityType' => '\\rdyescapia\\StructType\\UnitAmenityType',
            'UnitStayCandidateType' => '\\rdyescapia\\StructType\\UnitStayCandidateType',
            'ArrayOfRoomCountType' => '\\rdyescapia\\ArrayType\\ArrayOfRoomCountType',
            'RoomCountType' => '\\rdyescapia\\StructType\\RoomCountType',
            'ArrayOfBedCountType' => '\\rdyescapia\\ArrayType\\ArrayOfBedCountType',
            'BedCountType' => '\\rdyescapia\\StructType\\BedCountType',
            'PetsPoliciesType' => '\\rdyescapia\\StructType\\PetsPoliciesType',
            'PetsPolicy' => '\\rdyescapia\\StructType\\PetsPolicy',
            'UnitValueMatchType' => '\\rdyescapia\\StructType\\UnitValueMatchType',
            'RateRange' => '\\rdyescapia\\StructType\\RateRange',
            'LastMinuteDiscountRangeType' => '\\rdyescapia\\StructType\\LastMinuteDiscountRangeType',
            'ArrayOfParagraphType' => '\\rdyescapia\\ArrayType\\ArrayOfParagraphType',
            'ArrayOfDamageWaiverOptionType' => '\\rdyescapia\\ArrayType\\ArrayOfDamageWaiverOptionType',
            'DamageWaiverOptionType' => '\\rdyescapia\\StructType\\DamageWaiverOptionType',
            'Coverage' => '\\rdyescapia\\StructType\\Coverage',
            'ArrayOfResGuestRPHsTypeResGuestRPH' => '\\rdyescapia\\ArrayType\\ArrayOfResGuestRPHsTypeResGuestRPH',
            'ResGuestRPH' => '\\rdyescapia\\StructType\\ResGuestRPH',
            'ArrayOfCommentTypeComment' => '\\rdyescapia\\ArrayType\\ArrayOfCommentTypeComment',
            'Comment' => '\\rdyescapia\\StructType\\Comment',
            'ArrayOfSpecialRequestTypeSpecialRequest' => '\\rdyescapia\\ArrayType\\ArrayOfSpecialRequestTypeSpecialRequest',
            'SpecialRequest' => '\\rdyescapia\\StructType\\SpecialRequest',
            'ArrayOfServiceRPHsTypeServiceRPH' => '\\rdyescapia\\ArrayType\\ArrayOfServiceRPHsTypeServiceRPH',
            'ServiceRPH' => '\\rdyescapia\\StructType\\ServiceRPH',
            'OverriddenUnitStayRateType' => '\\rdyescapia\\StructType\\OverriddenUnitStayRateType',
            'ArrayOfServicesTypeService' => '\\rdyescapia\\ArrayType\\ArrayOfServicesTypeService',
            'Service' => '\\rdyescapia\\StructType\\Service',
            'AmountType' => '\\rdyescapia\\StructType\\AmountType',
            'AdditionalCharge' => '\\rdyescapia\\StructType\\AdditionalCharge',
            'ResCommonDetailType' => '\\rdyescapia\\StructType\\ResCommonDetailType',
            'ArrayOfMembershipTypeMembership' => '\\rdyescapia\\ArrayType\\ArrayOfMembershipTypeMembership',
            'Membership' => '\\rdyescapia\\StructType\\Membership',
            'GuaranteeType' => '\\rdyescapia\\StructType\\GuaranteeType',
            'ArrayOfGuaranteeTypeGuaranteeAccepted' => '\\rdyescapia\\ArrayType\\ArrayOfGuaranteeTypeGuaranteeAccepted',
            'GuaranteeAccepted' => '\\rdyescapia\\StructType\\GuaranteeAccepted',
            'EVRN_ResGlobalInfoType' => '\\rdyescapia\\StructType\\EVRN_ResGlobalInfoType',
            'ArrayOfUnitReservationIDsTypeUnitReservationID' => '\\rdyescapia\\ArrayType\\ArrayOfUnitReservationIDsTypeUnitReservationID',
            'UnitReservationID' => '\\rdyescapia\\StructType\\UnitReservationID',
            'ArrayOfRoutingHopTypeRoutingHop' => '\\rdyescapia\\ArrayType\\ArrayOfRoutingHopTypeRoutingHop',
            'RoutingHop' => '\\rdyescapia\\StructType\\RoutingHop',
            'ArrayOfProfilesTypeProfileInfo' => '\\rdyescapia\\ArrayType\\ArrayOfProfilesTypeProfileInfo',
            'ProfileInfo' => '\\rdyescapia\\StructType\\ProfileInfo',
            'ProfileType' => '\\rdyescapia\\StructType\\ProfileType',
            'AccessesType' => '\\rdyescapia\\StructType\\AccessesType',
            'Access' => '\\rdyescapia\\StructType\\Access',
            'PersonNameType' => '\\rdyescapia\\StructType\\PersonNameType',
            'FreeTextType' => '\\rdyescapia\\StructType\\FreeTextType',
            'CertificationType' => '\\rdyescapia\\StructType\\CertificationType',
            'CommissionInfoType' => '\\rdyescapia\\StructType\\CommissionInfoType',
            'ErrorType' => '\\rdyescapia\\StructType\\ErrorType',
            'WarningType' => '\\rdyescapia\\StructType\\WarningType',
            'CustomerType' => '\\rdyescapia\\StructType\\CustomerType',
            'Telephone' => '\\rdyescapia\\StructType\\Telephone',
            'CitizenCountryName' => '\\rdyescapia\\StructType\\CitizenCountryName',
            'CustLoyalty' => '\\rdyescapia\\StructType\\CustLoyalty',
            'EmailType' => '\\rdyescapia\\StructType\\EmailType',
            'URL_Type' => '\\rdyescapia\\StructType\\URL_Type',
            'RelatedTravelerType' => '\\rdyescapia\\StructType\\RelatedTravelerType',
            'ContactPersonType' => '\\rdyescapia\\StructType\\ContactPersonType',
            'EmployeeInfoType' => '\\rdyescapia\\StructType\\EmployeeInfoType',
            'DocumentType' => '\\rdyescapia\\StructType\\DocumentType',
            'ArrayOfString' => '\\rdyescapia\\ArrayType\\ArrayOfString',
            'PreferencesType' => '\\rdyescapia\\StructType\\PreferencesType',
            'PrefCollection' => '\\rdyescapia\\StructType\\PrefCollection',
            'CommonPrefType' => '\\rdyescapia\\StructType\\CommonPrefType',
            'NamePrefType' => '\\rdyescapia\\StructType\\NamePrefType',
            'PhonePrefType' => '\\rdyescapia\\StructType\\PhonePrefType',
            'AddressPrefType' => '\\rdyescapia\\StructType\\AddressPrefType',
            'PaymentFormPrefType' => '\\rdyescapia\\StructType\\PaymentFormPrefType',
            'InterestPrefType' => '\\rdyescapia\\StructType\\InterestPrefType',
            'InsurancePrefType' => '\\rdyescapia\\StructType\\InsurancePrefType',
            'SeatingPrefType' => '\\rdyescapia\\StructType\\SeatingPrefType',
            'TicketDistribPrefType' => '\\rdyescapia\\StructType\\TicketDistribPrefType',
            'MediaEntertainPrefType' => '\\rdyescapia\\StructType\\MediaEntertainPrefType',
            'PetInfoPrefType' => '\\rdyescapia\\StructType\\PetInfoPrefType',
            'MealPrefType' => '\\rdyescapia\\StructType\\MealPrefType',
            'LoyaltyPrefType' => '\\rdyescapia\\StructType\\LoyaltyPrefType',
            'SpecRequestPrefType' => '\\rdyescapia\\StructType\\SpecRequestPrefType',
            'RelatedTravelerPrefType' => '\\rdyescapia\\StructType\\RelatedTravelerPrefType',
            'VehicleProfileRentalPrefType' => '\\rdyescapia\\StructType\\VehicleProfileRentalPrefType',
            'LoyaltyPref' => '\\rdyescapia\\StructType\\LoyaltyPref',
            'PaymentFormPref' => '\\rdyescapia\\StructType\\PaymentFormPref',
            'CoveragePref' => '\\rdyescapia\\StructType\\CoveragePref',
            'SpecialEquipPref' => '\\rdyescapia\\StructType\\SpecialEquipPref',
            'VehicleSpecialReqPrefType' => '\\rdyescapia\\StructType\\VehicleSpecialReqPrefType',
            'VehiclePrefType' => '\\rdyescapia\\StructType\\VehiclePrefType',
            'VehicleCoreType' => '\\rdyescapia\\StructType\\VehicleCoreType',
            'VehType' => '\\rdyescapia\\StructType\\VehType',
            'VehClass' => '\\rdyescapia\\StructType\\VehClass',
            'AirlinePrefType' => '\\rdyescapia\\StructType\\AirlinePrefType',
            'FareRestrictPref' => '\\rdyescapia\\StructType\\FareRestrictPref',
            'FlightTypePref' => '\\rdyescapia\\StructType\\FlightTypePref',
            'CabinPref' => '\\rdyescapia\\StructType\\CabinPref',
            'SeatPref' => '\\rdyescapia\\StructType\\SeatPref',
            'SSR_Pref' => '\\rdyescapia\\StructType\\SSR_Pref',
            'AirportPrefType' => '\\rdyescapia\\StructType\\AirportPrefType',
            'LocationType' => '\\rdyescapia\\StructType\\LocationType',
            'EquipmentTypePref' => '\\rdyescapia\\StructType\\EquipmentTypePref',
            'EquipmentType' => '\\rdyescapia\\StructType\\EquipmentType',
            'HotelPrefType' => '\\rdyescapia\\StructType\\HotelPrefType',
            'PropertyNamePrefType' => '\\rdyescapia\\StructType\\PropertyNamePrefType',
            'PropertyLocationPrefType' => '\\rdyescapia\\StructType\\PropertyLocationPrefType',
            'PropertyTypePrefType' => '\\rdyescapia\\StructType\\PropertyTypePrefType',
            'PropertyClassPrefType' => '\\rdyescapia\\StructType\\PropertyClassPrefType',
            'PropertyAmenityPrefType' => '\\rdyescapia\\StructType\\PropertyAmenityPrefType',
            'RoomAmenityPrefType' => '\\rdyescapia\\StructType\\RoomAmenityPrefType',
            'RoomLocationPrefType' => '\\rdyescapia\\StructType\\RoomLocationPrefType',
            'BedTypePrefType' => '\\rdyescapia\\StructType\\BedTypePrefType',
            'FoodSrvcPrefType' => '\\rdyescapia\\StructType\\FoodSrvcPrefType',
            'RecreationSrvcPrefType' => '\\rdyescapia\\StructType\\RecreationSrvcPrefType',
            'BusinessSrvcPrefType' => '\\rdyescapia\\StructType\\BusinessSrvcPrefType',
            'PersonalSrvcPrefType' => '\\rdyescapia\\StructType\\PersonalSrvcPrefType',
            'SecurityFeaturePrefType' => '\\rdyescapia\\StructType\\SecurityFeaturePrefType',
            'PhysChallFeaturePrefType' => '\\rdyescapia\\StructType\\PhysChallFeaturePrefType',
            'OtherSrvcPrefType' => '\\rdyescapia\\StructType\\OtherSrvcPrefType',
            'CompanyInfoType' => '\\rdyescapia\\StructType\\CompanyInfoType',
            'TelephoneInfoType' => '\\rdyescapia\\StructType\\TelephoneInfoType',
            'LoyaltyProgramType' => '\\rdyescapia\\StructType\\LoyaltyProgramType',
            'AffiliationsType' => '\\rdyescapia\\StructType\\AffiliationsType',
            'OrganizationType' => '\\rdyescapia\\StructType\\OrganizationType',
            'OrgMemberName' => '\\rdyescapia\\StructType\\OrgMemberName',
            'EmployerType' => '\\rdyescapia\\StructType\\EmployerType',
            'TravelClubType' => '\\rdyescapia\\StructType\\TravelClubType',
            'ClubMemberName' => '\\rdyescapia\\StructType\\ClubMemberName',
            'InsuranceType' => '\\rdyescapia\\StructType\\InsuranceType',
            'AgreementsType' => '\\rdyescapia\\StructType\\AgreementsType',
            'AllianceConsortiumType' => '\\rdyescapia\\StructType\\AllianceConsortiumType',
            'AllianceMember' => '\\rdyescapia\\StructType\\AllianceMember',
            'PropertyManagerType' => '\\rdyescapia\\StructType\\PropertyManagerType',
            'ServiceFeeType' => '\\rdyescapia\\StructType\\ServiceFeeType',
            'ResGlobalInfoType' => '\\rdyescapia\\StructType\\ResGlobalInfoType',
            'ArrayOfHotelReservationIDsTypeHotelReservationID' => '\\rdyescapia\\ArrayType\\ArrayOfHotelReservationIDsTypeHotelReservationID',
            'HotelReservationID' => '\\rdyescapia\\StructType\\HotelReservationID',
            'ArrayOfResGuestsTypeResGuest' => '\\rdyescapia\\ArrayType\\ArrayOfResGuestsTypeResGuest',
            'ResGuest' => '\\rdyescapia\\StructType\\ResGuest',
            'ArrayOfResGuestsTypeResGuestProfileRPH' => '\\rdyescapia\\ArrayType\\ArrayOfResGuestsTypeResGuestProfileRPH',
            'ProfileRPH' => '\\rdyescapia\\StructType\\ProfileRPH',
            'TransportInfoType' => '\\rdyescapia\\StructType\\TransportInfoType',
            'TransportInfo' => '\\rdyescapia\\StructType\\TransportInfo',
            'WrittenConfInstType' => '\\rdyescapia\\StructType\\WrittenConfInstType',
            'ArrayOfUnitDescriptiveInfoRequestType' => '\\rdyescapia\\ArrayType\\ArrayOfUnitDescriptiveInfoRequestType',
            'UnitDescriptiveInfoRequestType' => '\\rdyescapia\\StructType\\UnitDescriptiveInfoRequestType',
            'UnitInfo' => '\\rdyescapia\\StructType\\UnitInfo',
            'Policies' => '\\rdyescapia\\StructType\\Policies',
            'UnitReviews' => '\\rdyescapia\\StructType\\UnitReviews',
            'Promotions' => '\\rdyescapia\\StructType\\Promotions',
            'EVRN_UnitDescriptiveInfoRS' => '\\rdyescapia\\StructType\\EVRN_UnitDescriptiveInfoRS',
            'UnitDescriptiveContents' => '\\rdyescapia\\StructType\\UnitDescriptiveContents',
            'EVRN_BaseRSType' => '\\rdyescapia\\StructType\\EVRN_BaseRSType',
            'UnitResResponseType' => '\\rdyescapia\\StructType\\UnitResResponseType',
            'ErrorsType' => '\\rdyescapia\\StructType\\ErrorsType',
            'SuccessType' => '\\rdyescapia\\StructType\\SuccessType',
            'WarningsType' => '\\rdyescapia\\StructType\\WarningsType',
            'EVRN_UnitCalendarAvailBatchRSType' => '\\rdyescapia\\StructType\\EVRN_UnitCalendarAvailBatchRSType',
            'UnitCalendarAvails' => '\\rdyescapia\\StructType\\UnitCalendarAvails',
            'UnitCalendarAvailType' => '\\rdyescapia\\StructType\\UnitCalendarAvailType',
            'UnitCalendarAvailSegmentType' => '\\rdyescapia\\StructType\\UnitCalendarAvailSegmentType',
            'ArrayOfStayRequirementType' => '\\rdyescapia\\ArrayType\\ArrayOfStayRequirementType',
            'StayRequirementType' => '\\rdyescapia\\StructType\\StayRequirementType',
            'UnitDescriptiveContentType' => '\\rdyescapia\\StructType\\UnitDescriptiveContentType',
            'UnitInfoType' => '\\rdyescapia\\StructType\\UnitInfoType',
            'UnitName' => '\\rdyescapia\\StructType\\UnitName',
            'Descriptions' => '\\rdyescapia\\StructType\\Descriptions',
            'MultimediaDescriptions' => '\\rdyescapia\\StructType\\MultimediaDescriptions',
            'EVRN_CategoryCodesType' => '\\rdyescapia\\StructType\\EVRN_CategoryCodesType',
            'LocationCategory' => '\\rdyescapia\\StructType\\LocationCategory',
            'UnitCategory' => '\\rdyescapia\\StructType\\UnitCategory',
            'RoomInfo' => '\\rdyescapia\\StructType\\RoomInfo',
            'BedInfo' => '\\rdyescapia\\StructType\\BedInfo',
            'PropertyManagerCategory' => '\\rdyescapia\\StructType\\PropertyManagerCategory',
            'CustomCategoryGroupType' => '\\rdyescapia\\StructType\\CustomCategoryGroupType',
            'CustomCategoryType' => '\\rdyescapia\\StructType\\CustomCategoryType',
            'MultimediaDescriptionsType' => '\\rdyescapia\\StructType\\MultimediaDescriptionsType',
            'MultimediaDescriptionType' => '\\rdyescapia\\StructType\\MultimediaDescriptionType',
            'VideoItems' => '\\rdyescapia\\StructType\\VideoItems',
            'ImageItemsType' => '\\rdyescapia\\StructType\\ImageItemsType',
            'ImageItem' => '\\rdyescapia\\StructType\\ImageItem',
            'ImageDescriptionType' => '\\rdyescapia\\StructType\\ImageDescriptionType',
            'ImageFormat' => '\\rdyescapia\\StructType\\ImageFormat',
            'Description' => '\\rdyescapia\\StructType\\Description',
            'ImageItemType' => '\\rdyescapia\\StructType\\ImageItemType',
            'TextItemsType' => '\\rdyescapia\\StructType\\TextItemsType',
            'TextItem' => '\\rdyescapia\\StructType\\TextItem',
            'TextDescriptionType' => '\\rdyescapia\\StructType\\TextDescriptionType',
            'VideoItemsType' => '\\rdyescapia\\StructType\\VideoItemsType',
            'VideoItem' => '\\rdyescapia\\StructType\\VideoItem',
            'VideoDescriptionType' => '\\rdyescapia\\StructType\\VideoDescriptionType',
            'VideoFormat' => '\\rdyescapia\\StructType\\VideoFormat',
            'VideoItemType' => '\\rdyescapia\\StructType\\VideoItemType',
            'ArrayOfUnitInfoTypeService' => '\\rdyescapia\\ArrayType\\ArrayOfUnitInfoTypeService',
            'DescriptiveText' => '\\rdyescapia\\StructType\\DescriptiveText',
            'TextValue' => '\\rdyescapia\\StructType\\TextValue',
            'RelativePositionType' => '\\rdyescapia\\StructType\\RelativePositionType',
            'TransportationsType' => '\\rdyescapia\\StructType\\TransportationsType',
            'ArrayOfTransportationTypeTransportation' => '\\rdyescapia\\ArrayType\\ArrayOfTransportationTypeTransportation',
            'Transportation' => '\\rdyescapia\\StructType\\Transportation',
            'OperationSchedulesType' => '\\rdyescapia\\StructType\\OperationSchedulesType',
            'OperationScheduleType' => '\\rdyescapia\\StructType\\OperationScheduleType',
            'ArrayOfOperationScheduleTypeOperationTime' => '\\rdyescapia\\ArrayType\\ArrayOfOperationScheduleTypeOperationTime',
            'OperationTime' => '\\rdyescapia\\StructType\\OperationTime',
            'OperationSchedulePlusChargeType' => '\\rdyescapia\\StructType\\OperationSchedulePlusChargeType',
            'ArrayOfOperationSchedulesPlusChargeTypeOperationSchedule' => '\\rdyescapia\\ArrayType\\ArrayOfOperationSchedulesPlusChargeTypeOperationSchedule',
            'OperationSchedule' => '\\rdyescapia\\StructType\\OperationSchedule',
            'ArrayOfFeaturesTypeFeature' => '\\rdyescapia\\ArrayType\\ArrayOfFeaturesTypeFeature',
            'Feature' => '\\rdyescapia\\StructType\\Feature',
            'Charge' => '\\rdyescapia\\StructType\\Charge',
            'ArrayOfRateRangeType' => '\\rdyescapia\\ArrayType\\ArrayOfRateRangeType',
            'RateRangeType' => '\\rdyescapia\\StructType\\RateRangeType',
            'DistributionType' => '\\rdyescapia\\StructType\\DistributionType',
            'SettingsType' => '\\rdyescapia\\StructType\\SettingsType',
            'ShowExactLocationType' => '\\rdyescapia\\StructType\\ShowExactLocationType',
            'ArrayOfEVRN_PoliciesTypePolicy' => '\\rdyescapia\\ArrayType\\ArrayOfEVRN_PoliciesTypePolicy',
            'Policy' => '\\rdyescapia\\StructType\\Policy',
            'PolicyInfo' => '\\rdyescapia\\StructType\\PolicyInfo',
            'CommissionPoliciesType' => '\\rdyescapia\\StructType\\CommissionPoliciesType',
            'UnitReviewsType' => '\\rdyescapia\\StructType\\UnitReviewsType',
            'UnitReviewType' => '\\rdyescapia\\StructType\\UnitReviewType',
            'ReviewScoreType' => '\\rdyescapia\\StructType\\ReviewScoreType',
            'ReviewCommentType' => '\\rdyescapia\\StructType\\ReviewCommentType',
            'ManagerResponseType' => '\\rdyescapia\\StructType\\ManagerResponseType',
            'PropertyManagerReviewType' => '\\rdyescapia\\StructType\\PropertyManagerReviewType',
            'PromotionsType' => '\\rdyescapia\\StructType\\PromotionsType',
            'EVRN_UnitSearchRQ' => '\\rdyescapia\\StructType\\EVRN_UnitSearchRQ',
            'UnitSearchCriteriaType' => '\\rdyescapia\\StructType\\UnitSearchCriteriaType',
            'UnitSearchCriterionType' => '\\rdyescapia\\StructType\\UnitSearchCriterionType',
            'ItemSearchCriterionType' => '\\rdyescapia\\StructType\\ItemSearchCriterionType',
            'UnitRef' => '\\rdyescapia\\StructType\\UnitRef',
            'Radius' => '\\rdyescapia\\StructType\\Radius',
            'RegionType' => '\\rdyescapia\\StructType\\RegionType',
            'RegionIdentifierType' => '\\rdyescapia\\StructType\\RegionIdentifierType',
            'EVRN_UnitSearchRS' => '\\rdyescapia\\StructType\\EVRN_UnitSearchRS',
            'Areas' => '\\rdyescapia\\StructType\\Areas',
            'Units' => '\\rdyescapia\\StructType\\Units',
            'SearchAreaType' => '\\rdyescapia\\StructType\\SearchAreaType',
            'UnitCount' => '\\rdyescapia\\StructType\\UnitCount',
            'AreaType' => '\\rdyescapia\\StructType\\AreaType',
            'UnitsType' => '\\rdyescapia\\StructType\\UnitsType',
            'EVRN_UnitCalendarAvailRQ' => '\\rdyescapia\\StructType\\EVRN_UnitCalendarAvailRQ',
            'EVRN_UnitCalendarAvailRS' => '\\rdyescapia\\StructType\\EVRN_UnitCalendarAvailRS',
            'UnitCalendarAvailSegments' => '\\rdyescapia\\StructType\\UnitCalendarAvailSegments',
            'UnitCalendarAvailSegment' => '\\rdyescapia\\StructType\\UnitCalendarAvailSegment',
            'EVRN_UnitStayRQ' => '\\rdyescapia\\StructType\\EVRN_UnitStayRQ',
            'DepositPayments' => '\\rdyescapia\\StructType\\DepositPayments',
            'CancelPenalties' => '\\rdyescapia\\StructType\\CancelPenalties',
            'BasicUnitInfo' => '\\rdyescapia\\StructType\\BasicUnitInfo',
            'RentalAgreement' => '\\rdyescapia\\StructType\\RentalAgreement',
            'EVRN_UnitStayRS' => '\\rdyescapia\\StructType\\EVRN_UnitStayRS',
            'EVRN_UnitReadRQ' => '\\rdyescapia\\StructType\\EVRN_UnitReadRQ',
            'ReadRequests' => '\\rdyescapia\\StructType\\ReadRequests',
            'GlobalReservationReadRequest' => '\\rdyescapia\\StructType\\GlobalReservationReadRequest',
            'ReadRequest' => '\\rdyescapia\\StructType\\ReadRequest',
            'VerificationType' => '\\rdyescapia\\StructType\\VerificationType',
            'PersonName' => '\\rdyescapia\\StructType\\PersonName',
            'TelephoneInfo' => '\\rdyescapia\\StructType\\TelephoneInfo',
            'ReservationTimeSpan' => '\\rdyescapia\\StructType\\ReservationTimeSpan',
            'AssociatedQuantity' => '\\rdyescapia\\StructType\\AssociatedQuantity',
            'StartLocation' => '\\rdyescapia\\StructType\\StartLocation',
            'EndLocation' => '\\rdyescapia\\StructType\\EndLocation',
            'EVRN_UnitInquiryRQ' => '\\rdyescapia\\StructType\\EVRN_UnitInquiryRQ',
            'ArrayOfInquiryRequestType' => '\\rdyescapia\\ArrayType\\ArrayOfInquiryRequestType',
            'InquiryRequestType' => '\\rdyescapia\\StructType\\InquiryRequestType',
            'Contact' => '\\rdyescapia\\StructType\\Contact',
            'Source' => '\\rdyescapia\\StructType\\Source',
            'EVRN_UnitInquiryRS' => '\\rdyescapia\\StructType\\EVRN_UnitInquiryRS',
            'EVRN_UnitCalendarAvailBatchRQ' => '\\rdyescapia\\StructType\\EVRN_UnitCalendarAvailBatchRQ',
            'ArrayOfCalendarAvailType' => '\\rdyescapia\\ArrayType\\ArrayOfCalendarAvailType',
            'CalendarAvailType' => '\\rdyescapia\\StructType\\CalendarAvailType',
            'EVRN_CampaignRQ' => '\\rdyescapia\\StructType\\EVRN_CampaignRQ',
            'ArrayOfCampaignRequestType' => '\\rdyescapia\\ArrayType\\ArrayOfCampaignRequestType',
            'CampaignRequestType' => '\\rdyescapia\\StructType\\CampaignRequestType',
            'EVRN_CampaignRS' => '\\rdyescapia\\StructType\\EVRN_CampaignRS',
            'Campaigns' => '\\rdyescapia\\StructType\\Campaigns',
            'CampaignType' => '\\rdyescapia\\StructType\\CampaignType',
            'CampaignKeywordReferralType' => '\\rdyescapia\\StructType\\CampaignKeywordReferralType',
            'EVRN_PropertyManagerRQ' => '\\rdyescapia\\StructType\\EVRN_PropertyManagerRQ',
            'PropertyManagerRequests' => '\\rdyescapia\\StructType\\PropertyManagerRequests',
            'PropertyManagerRequestType' => '\\rdyescapia\\StructType\\PropertyManagerRequestType',
            'EVRN_PropertyManagerRS' => '\\rdyescapia\\StructType\\EVRN_PropertyManagerRS',
            'PropertyManagers' => '\\rdyescapia\\StructType\\PropertyManagers',
            'EVRN_UnitHoldRQ' => '\\rdyescapia\\StructType\\EVRN_UnitHoldRQ',
            'EVRN_UnitHoldRS' => '\\rdyescapia\\StructType\\EVRN_UnitHoldRS',
            'UnitHolds' => '\\rdyescapia\\StructType\\UnitHolds',
            'EVRN_ReservationCancelRQ' => '\\rdyescapia\\StructType\\EVRN_ReservationCancelRQ',
            'EVRN_ReservationCancelRS' => '\\rdyescapia\\StructType\\EVRN_ReservationCancelRS',
            'EVRN_ReservationUpdateRQ' => '\\rdyescapia\\StructType\\EVRN_ReservationUpdateRQ',
            'EVRN_ReservationUpdateRS' => '\\rdyescapia\\StructType\\EVRN_ReservationUpdateRS',
            'ReservationUpdate' => '\\rdyescapia\\StructType\\ReservationUpdate',
            'ArrayOfReservationUpdateUnitRate' => '\\rdyescapia\\ArrayType\\ArrayOfReservationUpdateUnitRate',
            'EVRN_BookingChannelsRQ' => '\\rdyescapia\\StructType\\EVRN_BookingChannelsRQ',
            'EVRN_BookingChannelsRS' => '\\rdyescapia\\StructType\\EVRN_BookingChannelsRS',
            'BookingChannels' => '\\rdyescapia\\StructType\\BookingChannels',
        );
    }
}
