<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookingChannels StructType
 * @subpackage Structs
 */
class BookingChannels extends AbstractStructBase
{
    /**
     * The BookingChannel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapia\StructType\BookingChannelType[]
     */
    public $BookingChannel;
    /**
     * Constructor method for BookingChannels
     * @uses BookingChannels::setBookingChannel()
     * @param \rdyescapia\StructType\BookingChannelType[] $bookingChannel
     */
    public function __construct(array $bookingChannel = array())
    {
        $this
            ->setBookingChannel($bookingChannel);
    }
    /**
     * Get BookingChannel value
     * @return \rdyescapia\StructType\BookingChannelType[]|null
     */
    public function getBookingChannel()
    {
        return $this->BookingChannel;
    }
    /**
     * This method is responsible for validating the values passed to the setBookingChannel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBookingChannel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBookingChannelForArrayConstraintsFromSetBookingChannel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bookingChannelsBookingChannelItem) {
            // validation for constraint: itemType
            if (!$bookingChannelsBookingChannelItem instanceof \rdyescapia\StructType\BookingChannelType) {
                $invalidValues[] = is_object($bookingChannelsBookingChannelItem) ? get_class($bookingChannelsBookingChannelItem) : sprintf('%s(%s)', gettype($bookingChannelsBookingChannelItem), var_export($bookingChannelsBookingChannelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BookingChannel property can only contain items of type \rdyescapia\StructType\BookingChannelType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BookingChannel value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\BookingChannelType[] $bookingChannel
     * @return \rdyescapia\StructType\BookingChannels
     */
    public function setBookingChannel(array $bookingChannel = array())
    {
        // validation for constraint: array
        if ('' !== ($bookingChannelArrayErrorMessage = self::validateBookingChannelForArrayConstraintsFromSetBookingChannel($bookingChannel))) {
            throw new \InvalidArgumentException($bookingChannelArrayErrorMessage, __LINE__);
        }
        $this->BookingChannel = $bookingChannel;
        return $this;
    }
    /**
     * Add item to BookingChannel value
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\BookingChannelType $item
     * @return \rdyescapia\StructType\BookingChannels
     */
    public function addToBookingChannel(\rdyescapia\StructType\BookingChannelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapia\StructType\BookingChannelType) {
            throw new \InvalidArgumentException(sprintf('The BookingChannel property can only contain items of type \rdyescapia\StructType\BookingChannelType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BookingChannel[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\BookingChannels
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
