<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitDescriptiveInfoRQ StructType
 * @subpackage Structs
 */
class EVRN_UnitDescriptiveInfoRQ extends EVRN_BaseRQType
{
    /**
     * The UnitDescriptiveInfos
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType
     */
    public $UnitDescriptiveInfos;
    /**
     * The SummaryOnly
     * Meta information extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $SummaryOnly;
    /**
     * Constructor method for EVRN_UnitDescriptiveInfoRQ
     * @uses EVRN_UnitDescriptiveInfoRQ::setUnitDescriptiveInfos()
     * @uses EVRN_UnitDescriptiveInfoRQ::setSummaryOnly()
     * @param \rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType $unitDescriptiveInfos
     * @param bool $summaryOnly
     */
    public function __construct(\rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType $unitDescriptiveInfos = null, $summaryOnly = false)
    {
        $this
            ->setUnitDescriptiveInfos($unitDescriptiveInfos)
            ->setSummaryOnly($summaryOnly);
    }
    /**
     * Get UnitDescriptiveInfos value
     * @return \rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType|null
     */
    public function getUnitDescriptiveInfos()
    {
        return $this->UnitDescriptiveInfos;
    }
    /**
     * Set UnitDescriptiveInfos value
     * @param \rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType $unitDescriptiveInfos
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRQ
     */
    public function setUnitDescriptiveInfos(\rdyescapia\ArrayType\ArrayOfUnitDescriptiveInfoRequestType $unitDescriptiveInfos = null)
    {
        $this->UnitDescriptiveInfos = $unitDescriptiveInfos;
        return $this;
    }
    /**
     * Get SummaryOnly value
     * @return bool|null
     */
    public function getSummaryOnly()
    {
        return $this->SummaryOnly;
    }
    /**
     * Set SummaryOnly value
     * @param bool $summaryOnly
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRQ
     */
    public function setSummaryOnly($summaryOnly = false)
    {
        // validation for constraint: boolean
        if (!is_null($summaryOnly) && !is_bool($summaryOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($summaryOnly, true), gettype($summaryOnly)), __LINE__);
        }
        $this->SummaryOnly = $summaryOnly;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
