<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitDescriptiveInfoRS StructType
 * @subpackage Structs
 */
class EVRN_UnitDescriptiveInfoRS extends EVRN_BaseRSType
{
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - choice: Errors | Success | UnitDescriptiveContents | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\ErrorsType
     */
    public $Errors;
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - choice: Errors | Success | UnitDescriptiveContents | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\SuccessType
     */
    public $Success;
    /**
     * The UnitDescriptiveContents
     * Meta information extracted from the WSDL
     * - choice: Errors | Success | UnitDescriptiveContents | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\UnitDescriptiveContents
     */
    public $UnitDescriptiveContents;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - choice: Errors | Success | UnitDescriptiveContents | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\StructType\WarningsType
     */
    public $Warnings;
    /**
     * Constructor method for EVRN_UnitDescriptiveInfoRS
     * @uses EVRN_UnitDescriptiveInfoRS::setErrors()
     * @uses EVRN_UnitDescriptiveInfoRS::setSuccess()
     * @uses EVRN_UnitDescriptiveInfoRS::setUnitDescriptiveContents()
     * @uses EVRN_UnitDescriptiveInfoRS::setWarnings()
     * @param \rdyescapia\StructType\ErrorsType $errors
     * @param \rdyescapia\StructType\SuccessType $success
     * @param \rdyescapia\StructType\UnitDescriptiveContents $unitDescriptiveContents
     * @param \rdyescapia\StructType\WarningsType $warnings
     */
    public function __construct(\rdyescapia\StructType\ErrorsType $errors = null, \rdyescapia\StructType\SuccessType $success = null, \rdyescapia\StructType\UnitDescriptiveContents $unitDescriptiveContents = null, \rdyescapia\StructType\WarningsType $warnings = null)
    {
        $this
            ->setErrors($errors)
            ->setSuccess($success)
            ->setUnitDescriptiveContents($unitDescriptiveContents)
            ->setWarnings($warnings);
    }
    /**
     * Get Errors value
     * @return \rdyescapia\StructType\ErrorsType|null
     */
    public function getErrors()
    {
        return isset($this->Errors) ? $this->Errors : null;
    }
    /**
     * This method is responsible for validating the value passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErrorsForChoiceConstraintsFromSetErrors($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Success',
            'UnitDescriptiveContents',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Errors can\'t be set as the property %s is already set. Only one property must be set among these properties: Errors, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Errors value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\ErrorsType $errors
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRS
     */
    public function setErrors(\rdyescapia\StructType\ErrorsType $errors = null)
    {
        // validation for constraint: choice(Errors, Success, UnitDescriptiveContents, Warnings)
        if ('' !== ($errorsChoiceErrorMessage = self::validateErrorsForChoiceConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsChoiceErrorMessage, __LINE__);
        }
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->Errors);
        } else {
            $this->Errors = $errors;
        }
        return $this;
    }
    /**
     * Get Success value
     * @return \rdyescapia\StructType\SuccessType|null
     */
    public function getSuccess()
    {
        return isset($this->Success) ? $this->Success : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSuccess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccess method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSuccessForChoiceConstraintsFromSetSuccess($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'UnitDescriptiveContents',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Success can\'t be set as the property %s is already set. Only one property must be set among these properties: Success, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Success value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\SuccessType $success
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRS
     */
    public function setSuccess(\rdyescapia\StructType\SuccessType $success = null)
    {
        // validation for constraint: choice(Errors, Success, UnitDescriptiveContents, Warnings)
        if ('' !== ($successChoiceErrorMessage = self::validateSuccessForChoiceConstraintsFromSetSuccess($success))) {
            throw new \InvalidArgumentException($successChoiceErrorMessage, __LINE__);
        }
        if (is_null($success) || (is_array($success) && empty($success))) {
            unset($this->Success);
        } else {
            $this->Success = $success;
        }
        return $this;
    }
    /**
     * Get UnitDescriptiveContents value
     * @return \rdyescapia\StructType\UnitDescriptiveContents|null
     */
    public function getUnitDescriptiveContents()
    {
        return isset($this->UnitDescriptiveContents) ? $this->UnitDescriptiveContents : null;
    }
    /**
     * This method is responsible for validating the value passed to the setUnitDescriptiveContents method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitDescriptiveContents method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateUnitDescriptiveContentsForChoiceConstraintsFromSetUnitDescriptiveContents($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'Success',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property UnitDescriptiveContents can\'t be set as the property %s is already set. Only one property must be set among these properties: UnitDescriptiveContents, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set UnitDescriptiveContents value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\UnitDescriptiveContents $unitDescriptiveContents
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRS
     */
    public function setUnitDescriptiveContents(\rdyescapia\StructType\UnitDescriptiveContents $unitDescriptiveContents = null)
    {
        // validation for constraint: choice(Errors, Success, UnitDescriptiveContents, Warnings)
        if ('' !== ($unitDescriptiveContentsChoiceErrorMessage = self::validateUnitDescriptiveContentsForChoiceConstraintsFromSetUnitDescriptiveContents($unitDescriptiveContents))) {
            throw new \InvalidArgumentException($unitDescriptiveContentsChoiceErrorMessage, __LINE__);
        }
        if (is_null($unitDescriptiveContents) || (is_array($unitDescriptiveContents) && empty($unitDescriptiveContents))) {
            unset($this->UnitDescriptiveContents);
        } else {
            $this->UnitDescriptiveContents = $unitDescriptiveContents;
        }
        return $this;
    }
    /**
     * Get Warnings value
     * @return \rdyescapia\StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return isset($this->Warnings) ? $this->Warnings : null;
    }
    /**
     * This method is responsible for validating the value passed to the setWarnings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWarnings method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateWarningsForChoiceConstraintsFromSetWarnings($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'Success',
            'UnitDescriptiveContents',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Warnings can\'t be set as the property %s is already set. Only one property must be set among these properties: Warnings, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Warnings value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapia\StructType\WarningsType $warnings
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRS
     */
    public function setWarnings(\rdyescapia\StructType\WarningsType $warnings = null)
    {
        // validation for constraint: choice(Errors, Success, UnitDescriptiveContents, Warnings)
        if ('' !== ($warningsChoiceErrorMessage = self::validateWarningsForChoiceConstraintsFromSetWarnings($warnings))) {
            throw new \InvalidArgumentException($warningsChoiceErrorMessage, __LINE__);
        }
        if (is_null($warnings) || (is_array($warnings) && empty($warnings))) {
            unset($this->Warnings);
        } else {
            $this->Warnings = $warnings;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\EVRN_UnitDescriptiveInfoRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
