<?php

namespace rdyescapia\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResGlobalInfoType StructType
 * @subpackage Structs
 */
class ResGlobalInfoType extends ResCommonDetailType
{
    /**
     * The HotelReservationIDs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID
     */
    public $HotelReservationIDs;
    /**
     * The RoutingHops
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public $RoutingHops;
    /**
     * The Profiles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo
     */
    public $Profiles;
    /**
     * Constructor method for ResGlobalInfoType
     * @uses ResGlobalInfoType::setHotelReservationIDs()
     * @uses ResGlobalInfoType::setRoutingHops()
     * @uses ResGlobalInfoType::setProfiles()
     * @param \rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID $hotelReservationIDs
     * @param \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops
     * @param \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles
     */
    public function __construct(\rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID $hotelReservationIDs = null, \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops = null, \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles = null)
    {
        $this
            ->setHotelReservationIDs($hotelReservationIDs)
            ->setRoutingHops($routingHops)
            ->setProfiles($profiles);
    }
    /**
     * Get HotelReservationIDs value
     * @return \rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID|null
     */
    public function getHotelReservationIDs()
    {
        return $this->HotelReservationIDs;
    }
    /**
     * Set HotelReservationIDs value
     * @param \rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID $hotelReservationIDs
     * @return \rdyescapia\StructType\ResGlobalInfoType
     */
    public function setHotelReservationIDs(\rdyescapia\ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID $hotelReservationIDs = null)
    {
        $this->HotelReservationIDs = $hotelReservationIDs;
        return $this;
    }
    /**
     * Get RoutingHops value
     * @return \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop|null
     */
    public function getRoutingHops()
    {
        return $this->RoutingHops;
    }
    /**
     * Set RoutingHops value
     * @param \rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops
     * @return \rdyescapia\StructType\ResGlobalInfoType
     */
    public function setRoutingHops(\rdyescapia\ArrayType\ArrayOfRoutingHopTypeRoutingHop $routingHops = null)
    {
        $this->RoutingHops = $routingHops;
        return $this;
    }
    /**
     * Get Profiles value
     * @return \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo|null
     */
    public function getProfiles()
    {
        return $this->Profiles;
    }
    /**
     * Set Profiles value
     * @param \rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles
     * @return \rdyescapia\StructType\ResGlobalInfoType
     */
    public function setProfiles(\rdyescapia\ArrayType\ArrayOfProfilesTypeProfileInfo $profiles = null)
    {
        $this->Profiles = $profiles;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapia\StructType\ResGlobalInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
